#ifndef DECORATIVEOBJECTS_HPP_INCLUDED
#define DECORATIVEOBJECTS_HPP_INCLUDED

#include "../../Core/Classes/DecorativeObject.hpp"
#include "../../Core/Classes/ObjectInfo.hpp"
#include "../../Core/Types/Tile.hpp"
#include "../../Core/Types/Convex.hpp"
#include <functional>
#include <cstdint>
#include <vector>
#include <string>

/** @addtogroup Models
* @{ */
class DecorativeObjects
{
    public:

        static Internal::ObjectInfo GetInfoOf(const Internal::DecorativeObject& D);
        static Tile GetTileOf(const Internal::DecorativeObject& D);
        static std::vector<Point> GetModelOf(const Internal::DecorativeObject& D);
        static Convex GetConvexOf(const Internal::DecorativeObject& D);

        //consider changing to Interactable::GameObject
        static std::vector<Internal::DecorativeObject> GetAll();
        static std::vector<Internal::DecorativeObject> GetAll(std::int32_t ID);
        static std::vector<Internal::DecorativeObject> GetAll(const std::string& Name);
        static std::vector<Internal::DecorativeObject> GetAll(const std::vector<std::int32_t>& PossibleIDs);
        static std::vector<Internal::DecorativeObject> GetAll(const std::vector<std::string>& PossibleNames);
        static std::vector<Internal::DecorativeObject> GetAll(const std::function<bool (const Internal::DecorativeObject&)>& Filter);

        static Internal::DecorativeObject Get(const Tile& T);
        static Internal::DecorativeObject Get(std::int32_t ID);
        static Internal::DecorativeObject Get(const std::string& Name);
        static Internal::DecorativeObject Get(const std::vector<std::int32_t>& PossibleIDs);
        static Internal::DecorativeObject Get(const std::vector<std::string>& PossibleNames);
        static Internal::DecorativeObject Get(const std::function<bool (const Internal::DecorativeObject&)>& Filter);
};

/** @} */

#endif // DECORATIVEOBJECTS_HPP_INCLUDED
