#ifndef GROUNDITEMS_HPP_INCLUDED
#define GROUNDITEMS_HPP_INCLUDED

#include "../../Core/Classes/GroundItem.hpp"
#include "../../Core/Types/Tile.hpp"
#include "../../Core/Types/Convex.hpp"
#include <functional>
#include <cstdint>
#include <vector>
#include <string>

/** @addtogroup Models
* @{ */
class GroundItems
{
    public:
        static std::vector<Internal::GroundItem> GetAll();
        static std::vector<Internal::GroundItem> GetAll(Tile T);
        static std::vector<Internal::GroundItem> GetAll(std::int32_t ID);
        static std::vector<Internal::GroundItem> GetAll(const std::string& Name);
        static std::vector<Internal::GroundItem> GetAll(const std::vector<std::int32_t>& IDs);
        static std::vector<Internal::GroundItem> GetAll(const std::vector<std::string>& Names);
        static std::vector<Internal::GroundItem> GetAll(const std::function<bool (Internal::GroundItem&)>& Filter);

        static Internal::GroundItem Get(Tile T);
        static Internal::GroundItem Get(std::int32_t ID);
        static Internal::GroundItem Get(const std::string& Name);
        static Internal::GroundItem Get(const std::vector<std::int32_t>& IDs);
        static Internal::GroundItem Get(const std::vector<std::string>& Names);

        static Tile GetTileOf(Internal::GroundItem G);

        static Convex GetConvexOf(Internal::GroundItem G);
};
/** @} */

#endif // GROUNDITEMS_HPP_INCLUDED
